/* ************************************************************************ */
/*                             UPDATE 1.2.00_003                            */
/* ------------------------------------------------------------------------ */

-- drop the view in order to be able to change the type of the column billing.act.code
DROP VIEW billing.activity;

-- users are able to enter more than 5 letters into the code
ALTER TABLE billing.act ALTER COLUMN code TYPE varchar(10);
ALTER TABLE billing.rate ALTER COLUMN code TYPE varchar(10);

CREATE VIEW billing.activity (id, invoice_id, physician_id, patient_id, patient_first_name, patient_maiden_name, patient_name, patient_ssn, accession_number, performed, code, quantity, coefficient, key_value, suffixes, majoration) AS
 	SELECT DISTINCT act.id, act.invoice_id, act.physician_id, patient.id, patient.first_name, patient.maiden_name, patient.sur_name, patient.social_security_number, act.accession_number, act.performed, act.code, act.quantity, act.coefficient, act.key_value, act.suffixes, invoice.majoration
 	FROM billing.act, billing.invoice, patient.patient
 	WHERE invoice.id = act.invoice_id AND patient.id = invoice.patient_id;
 	
/**** UPDATE THE SCRIPTNAME BELOW TO THE FILENAME OF THIS FILE !!!!!!!! *****/
INSERT INTO "core"."info" (date,key,value) VALUES ('now','LAST_UPDATE' ,'db_update_1.2.00_003.sql');